<?php

class Ipqualityscore_Ipqualityscore_Model_Observer {
    public function loadPage($observer) {
        try {
            $path =  Mage::getBaseDir('base') . "/app/code/local/Ipqualityscore/Ipqualityscore/lib/Integration.php";
            require_once $path;
            $isAuthed = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_token');
            if( $isAuthed ){
                $blockAll = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_all');
                $blockVpn = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_vpn');
                $blockTor = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_tor');
                $strictness = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_strictness');
                $allowPublic = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_public');
                $allowCrawlers = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_crawlers');
                $blockScore = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_score');
                $redirect = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_redirect');
         	$deviceTracking =  Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_order_device');
                $client = new \IpqualityScore\Integration($isAuthed, 'magentov1');
                $response = $client->validateProxy($strictness, $allowPublic);
		if (!$response->cached) {
                    $response->valid_billing_address = '';
                    $response->valid_shipping_address = '';
                    $response->valid_billing_email = '';
                    $response->valid_shipping_email = '';
                    $response->risky_billing_phone = '';
                    $response->risky_shipping_phone = '';
                    $response->fraudulent_behaviour = '';
                    $response->risky_username = '';
                    $response->bin_country = '';
                    $response->valid_billing_phone = '';
                    $response->valid_shipping_phone = '';
                    $response->proxy = $response->proxy?1:0;
                    $response->vpn = $response->vpn?1:0;
                    $response->tor = $response->tor?1:0;
                    $response->recent_abuse = $response->recent_abuse?1:0;
                    $response->bot_status = $response->bot_status?1:0;
                    $response->mobile = $response->mobile?1:0;
                    $response->is_crawler = $response->is_crawler?1:0;
                    $resource = Mage::getSingleton('core/resource');
                    $writeConnection = $resource->getConnection('core_write');
                    $sql = "INSERT INTO ipqualityscore_proxy VALUES({$response->fraud_score},{$response->proxy},'{$response->ISP}','{$response->organization}','{$response->ASN}','{$response->host}',
                    '{$response->country_code}','{$response->city}','{$response->region}',{$response->is_crawler},'{$response->latitude}','{$response->longitude}','{$response->timezone}',
                    {$response->vpn},{$response->tor},{$response->recent_abuse},{$response->bot_status},{$response->mobile},'{$response->operating_system}','{$response->browser}','{$response->device_model}',
                    '{$response->device_model}','{$response->valid_billing_address}','{$response->valid_shipping_address}','{$response->valid_billing_email}','{$response->valid_shipping_email}',
                    '{$response->risky_billing_phone}','{$response->risky_shipping_phone}','{$response->fraudulent_behaviour}','{$response->bin_country}','{$response->risky_username}','{$response->valid_billing_phone}',
                    '{$response->valid_shipping_phone}','{$response->request_id}'
                    )";
                    $writeConnection->query($sql);
                }
                if ($response->vpn && ($blockAll || $blockVpn)) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }
                if ($response->tor && ($blockAll || $blockTor)) {
                   if ($allowCrawlers && $response->is_crawler) {
                   } else {
                       if ($redirect) {
                           header("Location: {$redirect}");
                       }
                   }
                   die();
                }
                if ($response->proxy &&  $blockAll) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
		}
                if ($blockScore && ($blockScore <= $response->fraud_score)) {
                    if ($allowCrawlers && $response->is_crawler) {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
		}
	    }

	}catch (\Exception $e){
            //echo $e->getMessage();die();
            //Mage::log($e->getMessage(),null,'ipqualityscorex.log',true);
        }
    }

    public function userLogin($observer) {
        try {
            $path =  Mage::getBaseDir('base') . "/app/code/local/Ipqualityscore/Ipqualityscore/lib/Integration.php";
            require_once $path;
            $isAuthed = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_token');
            if( $isAuthed ){
                $blockAll = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_all');
                $blockVpn = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_vpn');
                $blockTor = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_tor');
                $strictness = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_strictness');
                $allowPublic = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_public');
                $allowCrawlers = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_crawlers');
                $blockScore = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_score');
                $redirect = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_redirect');
                $blockUserProxyLogin =  Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_login');
                if ($blockUserProxyLogin) {
                    $client = new \IpqualityScore\Integration($isAuthed, 'magentov1');
                    $response = $client->validateProxy($strictness, $allowPublic);
                    if ($response->proxy || $response->vpn || $response->tor ) {
                        if ($allowCrawlers && $response->is_crawler) {
                        } else {
                            if ($redirect) {
                                header("Location: {$redirect}");
                            }
                        }
                        die();
                    }
                }
            }
	}catch (\Exception $e) {

	}
            
    }    

    public function adminLogin($observer) {
        try {
            $path =  Mage::getBaseDir('base') . "/app/code/local/Ipqualityscore/Ipqualityscore/lib/Integration.php";
            require_once $path;
            $isAuthed = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_token');
            if( $isAuthed ){
                $blockAll = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_all');
                $blockVpn = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_vpn');
                $blockTor = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_tor');
                $strictness = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_strictness');
                $allowPublic = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_public');
                $allowCrawlers = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_crawlers');
                $blockScore = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_score');
                $redirect = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_redirect');
                $allowAdminProxyLogin =  Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_allow_admin_login');
                if (!$allowAdminProxyLogin) {
                    $client = new \IpqualityScore\Integration($isAuthed, 'magentov1');
                    $response = $client->validateProxy($strictness, $allowPublic);
                    if ($response->proxy || $response->vpn || $response->tor ) {
                        if ($allowCrawlers && $response->is_crawler) {
                        } else {
                            if ($redirect) {
                                header("Location: {$redirect}");
                            }
                        }
                        die();
                    }
                }
            }
        }catch (\Exception $e) {
            //$this->logger->info($e->getMessage());
        }

    }

    public function successOrder($observer) {
        try {
            $path =  Mage::getBaseDir('base') . "/app/code/local/Ipqualityscore/Ipqualityscore/lib/Integration.php";
            require_once $path;
            $isAuthed = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_token');
            if( $isAuthed ){
                $blockAll = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_all');
                $blockVpn = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_vpn');
                $blockTor = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_tor');
                $strictness = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_strictness');
                $allowPublic = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_public');
                $allowCrawlers = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_crawlers');
                $blockScore = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_score');
                $redirect = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_redirect');
                $deviceTracking =  Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_order_device');
                $client = new \IpqualityScore\Integration($isAuthed, 'magentov1');

                if( $deviceTracking ) {
                    $orderId = Mage::getSingleton('checkout/session')->getLastRealOrderId();
                    $resource = \Mage::getSingleton('core/resource');
                    $readConnection = $resource->getConnection('core_read');
                    $sql = "SELECT * FROM ipqualityscore_devices WHERE order_id=" . $orderId;
                    $device = $readConnection->fetchAll($sql);
                    if( !$device ){
                        $trackingCode = $client->createDeviceTrackerUrl();
                        $baseUrl = Mage::getBaseUrl();
                        $url = $baseUrl . '/ipqualityscore/index/device';

                        echo $trackingCode;
                        echo "<script defer>
                        Startup.AfterResult(function(result){
		            if( result.success ){
            	                result.oid = {$orderId};
                                var ajaxRequest = new XMLHttpRequest();
                                ajaxRequest.open('POST', '$url', true);
                                ajaxRequest.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                                ajaxRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                                ajaxRequest.send('data=' + JSON.stringify(result));
                            }
                        });
                       </script>";
                    }
                 }
	     }
         }catch (\Exception $e) {
         }
    }

    public function getSalesOrderViewInfo(Varien_Event_Observer $observer) {
        $block = $observer->getBlock();
        if (($block->getNameInLayout() == 'order_info') && ($child = $block->getChild('ipqualityscore.order.info.custom.block'))) {
            $transport = $observer->getTransport();
            if ($transport) {
                $html = $transport->getHtml();
                $html .= $child->toHtml();
                $transport->setHtml($html);
            }
        }
    }

    public function newOrder( $observer ){
        try{
            $path =  Mage::getBaseDir('base') . "/app/code/local/Ipqualityscore/Ipqualityscore/lib/Integration.php";
            require_once $path;
            $isAuthed = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_token');
            if( $isAuthed ){
                $order = $observer->getEvent()->getOrder();
                $orderId = $order->getId();
                $customerId = $order->getCustomerId();
                $email = $order->getCustomerEmail();
                $firstname = $order->getCustomerFirstName();
                $lastname = $order->getCustomerLastname();
                $shipping= $order->getBillingAddress()->getData();
                $billing = $order->getBillingAddress()->getData();
                $blockAll = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_all');
                $blockVpn = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_vpn');
                $blockTor = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_block_tor');
                $strictness = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_strictness');
                $allowPublic = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_public');
                $allowCrawlers = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_crawlers');
                $blockScore = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_score');
                $redirect = Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_redirect');
                $deviceTracking =  Mage::getStoreConfig('general/ipqualityscore_group/ipqualityscore_order_device');
                $client = new \IpqualityScore\Integration($isAuthed, 'magentov1');
                $user = [
                    'billing_firstname' => $billing['firstname'],
                    'billing_lastname' => $billing['lastname'],
                    'billing_company' => $billing['company'],
                    'billing_country' => $billing['country_id'],
                    'billing_address' => $billing['street'],
                    'billing_city' => $billing['city'],
                    'billing_state' => $billing['region'],
                    'billing_postcalcode' => $billing['postcode'],
                    'billing_phone' => $billing['telephone'],
                    'billing_email' => $billing['email'],
                    'shipping_firstname' => $shipping['firstname'],
                    'shipping_lastname' => $shipping['lastname'],
                    'shipping_company' => $shipping['company'],
                    'shipping_country' => $shipping['country_id'],
                    'shipping_address' => $shipping['street'],
                    'shipping_city' => $shipping['city'],
                    'shipping_state' => $shipping['region'],
                    'shipping_postcalcode' => $shipping['postcode'],
                    'shipping_phone' => $shipping['telephone'],
                    'shipping_email' => $shipping['email']
                ];
                $response = $client->validateProxy($strictness, $allowPublic,false,true,$user);
//var_dump($response);die();
                $response->proxy = $response->proxy?1:0;
                $response->vpn = $response->vpn?1:0;
                $response->tor = $response->tor?1:0;
                $response->recent_abuse = $response->recent_abuse?1:0;
                $response->bot_status = $response->bot_status?1:0;
                $response->mobile = $response->mobile?1:0;
                $response->is_crawler = $response->is_crawler?1:0;
                $resource = Mage::getSingleton('core/resource');
                $writeConnection = $resource->getConnection('core_write');
                $sql = "INSERT INTO ipqualityscore_proxy VALUES({$response->fraud_score},{$response->proxy},'{$response->ISP}','{$response->organization}','{$response->ASN}','{$response->host}',
                '{$response->country_code}','{$response->city}','{$response->region}',{$response->is_crawler},'{$response->latitude}','{$response->longitude}','{$response->timezone}',
                {$response->vpn},{$response->tor},{$response->recent_abuse},{$response->bot_status},{$response->mobile},'{$response->operating_system}','{$response->browser}','{$response->device_model}',
                '{$response->device_model}','{$response->transaction_details->valid_billing_address}','{$response->transaction_details->valid_shipping_address}','{$response->transaction_details->valid_billing_email}','{$response->transaction_details->valid_shipping_email}',
                '{$response->transaction_details->risky_billing_phone}','{$response->transaction_details->risky_shipping_phone}','{$response->transaction_details->fraudulent_behavior}','{$response->transaction_details->bin_country}','{$response->transaction_details->risky_username}','{$response->transaction_details->valid_billing_phone}',
                '{$response->transaction_details->valid_shipping_phone}','{$response->request_id}'
                )";
                $writeConnection->query($sql);

                $emailResponse = $client->validateEmail( $email );
                $emailValid = $emailResponse->valid?1:0;
                $emailDisposable = $emailResponse->disposable?1:0;
                $emailTimedOut = $emailResponse->timed_out?1:0;
                $emailSuspect = $emailResponse->suspect?1:0;
                $emailSmptScore = $emailResponse->smtp_score?1:0;
                $emailOverAllScore = $emailResponse->overall_score?1:0; 
                $emailGeneric = $emailResponse->generic?1:0;
                $emailCommon = $emailResponse->common?1:0;
                $emailDnsValid = $emailResponse->dns_valid?1:0; 
                $emailHoneypot = $emailResponse->honeypot?1:0;
                $emailRecentAbuse = $emailResponse->recent_abuse?1:0;
                $emailFrequentComplainer = $emailResponse->frequent_complainer?1:0;
                $emailCatchAll = $emailResponse->catch_all?1:0;
                $emailLeaked = $emailResponse->leaked?1:0;
                if (!$emailResponse->cached) {
                    $sql = "INSERT INTO ipqualityscore_email VALUES(
                    '{$email}',{$emailValid},{$emailDisposable},{$emailTimedOut},'{$emailResponse->deliverability}','{$emailSuspect}','{$emailSmptScore}',{$emailOverAllScore},'{$emailResponse->first_name}',
                    '{$emailGeneric}','{$emailCommon}','{$emailDnsValid}','{$emailHoneypot}','{$emailRecentAbuse}','{$emailFrequentComplainer}','{$emailResponse->suggested_domain}','{$emailCatchAll}',
                    '{$emailResponse->spam_trap_score}','{$emailResponse->request_id}','{$emailLeaked}',0
                    )";
                    $writeConnection->query($sql);
                }
                $resource = \Mage::getSingleton('core/resource');
                $readConnection = $resource->getConnection('core_read');
                $sql = "SELECT * FROM ipqualityscore_devices WHERE order_id=" . $orderId;
                $device = $readConnection->fetchAll($sql);
                $proxyScore = $response->fraud_score;
                $emailScore =  $emailResponse->overall_score;
                $validPhone = $response->transaction_details->valid_billing_phone?1:null;
                $validAddress = $response->transaction_details->valid_billing_address?1:null;
                if($device){
                    $deviceScore = $device[0]->fraud_chance;
                }else{
                    $deviceScore = 0;
                }
                $requestId = $response->request_id; 
                $sql = "INSERT INTO ipqualityscore_orders  VALUES({$orderId},{$orderId},{$proxyScore},{$emailScore},{$deviceScore},'{$validPhone}','{$validAddress}',0,'{$requestId}')";
                $writeConnection->query($sql);
            }
        }catch (\Exception $e) {
               echo $e->getMessage();die();
         }

    }
}
